#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_DragonPalace.h"
std::auto_ptr<Fish_DragonPalace> Fish_DragonPalace::msSingleton(nullptr);

int Fish_DragonPalace::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DragonPalaceData* Fish_DragonPalace::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_DragonPalaceData>& Fish_DragonPalace::GetMapData()
{
	return mMapData;
}

void Fish_DragonPalace::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_DragonPalace.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DragonPalaceData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mIcon = element->Attribute("Icon");
		data.mString1 = element->Attribute("String1");
		{
			const char* String2 = element->Attribute("String2");
			std::vector<std::string> vecString2;
			boost::split(vecString2, String2, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecString2.size(); i++)
			{
				data.mString2.push_back(vecString2[i]);
			}
		}
		{
			const char* String3 = element->Attribute("String3");
			std::vector<std::string> vecString3;
			boost::split(vecString3, String3, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecString3.size(); i++)
			{
				data.mString3.push_back(vecString3[i]);
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_DragonPalace Loaded. Load Data:%u", mMapData.size());
}

void Fish_DragonPalace::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_DragonPalace");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_DragonPalace");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_DragonPalaceData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readString(L, "Icon", data.mIcon);
		LuaCfgHelper::readString(L, "String1", data.mString1);
		LuaCfgHelper::readVectorString(L, "String2", data.mString2);
		LuaCfgHelper::readVectorString(L, "String3", data.mString3);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_DragonPalace Loaded. Load Data:%u", mMapData.size());
}

void Fish_DragonPalace::Reload()
{
	mMapData.clear();
	Load();
}

Fish_DragonPalace* Fish_DragonPalace::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DragonPalace());
	}
	return msSingleton.get();
}

void Fish_DragonPalace::Release()
{
	msSingleton.reset(nullptr);
}
